#include <stdio.h>
#include <sys/errno.h>
#include <fcntl.h>
#include <sys/types.h>
#include <linux/cdrom.h>
#include <linux/soundcard.h>
#include "xpm/icon.xpm"
#include "xpm/redled.xpm"
#include "xpm/yelled.xpm"
#include "xpm/greenled.xpm"
#include "xpm/offled.xpm"

#include <forms.h>
#include "mixer.h"

int devmask, stereod, i, d;
int lcval[SOUND_MIXER_NRDEVICES];
int mixer_fd;      
int recsource;
int audiopci=0;
static FD_Mixer * mixui;
extern void do_setup(FD_Mixer *);
// lets try this hack
// 1=line 2=mic 3=cd, 4=pcm, 5=synth
int dev_left=2;
int dev_right=1;

typedef struct stereovolume
{
  u_char left;
  u_char right;
  u_char pad1;
  u_char pad2;
} StereoVolume;

int main(int argc, char *argv[])
{
 fl_initialize(&argc, argv, "Audio Mixer", 0, 0);
 mixui = create_form_Mixer();

 mixer_fd = open ("/dev/mixer", O_RDWR, 0);
   if (mixer_fd < 0)
       perror ("Error opening mixer device"), exit (1);

    if (ioctl(mixer_fd, SOUND_MIXER_READ_DEVMASK, &devmask) == -1) {
	perror("SOUND_MIXER_READ_DEVMASK");
	exit(-1);
    }
    if (ioctl(mixer_fd, SOUND_MIXER_READ_STEREODEVS, &stereod) == -1) {
	perror("SOUND_MIXER_READ_STEREODEVS");
	exit(-1);
    }

    if (!devmask) {
	fprintf(stderr, "No device found.");
	exit(-1);
    }

 printf("AudioMixer 1.2 by TimeCop [timecop@ops.linuxwarez.com]\n");

 do_setup(mixui);
 fl_show_form(mixui->Mixer,FL_PLACE_CENTER,FL_FULLBORDER,"Audio Mixer");
 fl_do_forms();

}

int getbits(int x, int p, int n)
{
 return (x>>(p+1-n))&~(~0<<n);
}
int calc_leds(int vlz)
{
 return ((vlz*8.999)/100);
}

void make_leds(int high)
{
 switch (high) {
  case 0: {
   fl_set_pixmap_data(mixui->led0, offled_xpm);
   fl_set_pixmap_data(mixui->led1, offled_xpm);
   fl_set_pixmap_data(mixui->led2, offled_xpm);
   fl_set_pixmap_data(mixui->led3, offled_xpm);
   fl_set_pixmap_data(mixui->led4, offled_xpm);
   fl_set_pixmap_data(mixui->led5, offled_xpm);
   fl_set_pixmap_data(mixui->led6, offled_xpm);
   fl_set_pixmap_data(mixui->led7, offled_xpm);
   break; }
  case 1: {
   fl_set_pixmap_data(mixui->led0, greenled_xpm);
   fl_set_pixmap_data(mixui->led1, offled_xpm);
   fl_set_pixmap_data(mixui->led2, offled_xpm);
   fl_set_pixmap_data(mixui->led3, offled_xpm);
   fl_set_pixmap_data(mixui->led4, offled_xpm);
   fl_set_pixmap_data(mixui->led5, offled_xpm);
   fl_set_pixmap_data(mixui->led6, offled_xpm);
   fl_set_pixmap_data(mixui->led7, offled_xpm);
   break; }
  case 2: {
   fl_set_pixmap_data(mixui->led0, greenled_xpm);
   fl_set_pixmap_data(mixui->led1, greenled_xpm);
   fl_set_pixmap_data(mixui->led2, offled_xpm);
   fl_set_pixmap_data(mixui->led3, offled_xpm);
   fl_set_pixmap_data(mixui->led4, offled_xpm);
   fl_set_pixmap_data(mixui->led5, offled_xpm);
   fl_set_pixmap_data(mixui->led6, offled_xpm);
   fl_set_pixmap_data(mixui->led7, offled_xpm);
   break; }
  case 3: {
   fl_set_pixmap_data(mixui->led0, greenled_xpm);
   fl_set_pixmap_data(mixui->led1, greenled_xpm);
   fl_set_pixmap_data(mixui->led2, greenled_xpm);
   fl_set_pixmap_data(mixui->led3, offled_xpm);
   fl_set_pixmap_data(mixui->led4, offled_xpm);
   fl_set_pixmap_data(mixui->led5, offled_xpm);
   fl_set_pixmap_data(mixui->led6, offled_xpm);
   fl_set_pixmap_data(mixui->led7, offled_xpm);
   break; }
  case 4: {
   fl_set_pixmap_data(mixui->led0, greenled_xpm);
   fl_set_pixmap_data(mixui->led1, greenled_xpm);
   fl_set_pixmap_data(mixui->led2, greenled_xpm);
   fl_set_pixmap_data(mixui->led3, greenled_xpm);
   fl_set_pixmap_data(mixui->led4, offled_xpm);
   fl_set_pixmap_data(mixui->led5, offled_xpm);
   fl_set_pixmap_data(mixui->led6, offled_xpm);
   fl_set_pixmap_data(mixui->led7, offled_xpm);
   break; }
  case 5: {
   fl_set_pixmap_data(mixui->led0, greenled_xpm);
   fl_set_pixmap_data(mixui->led1, greenled_xpm);
   fl_set_pixmap_data(mixui->led2, greenled_xpm);
   fl_set_pixmap_data(mixui->led3, greenled_xpm);
   fl_set_pixmap_data(mixui->led4, yelled_xpm);
   fl_set_pixmap_data(mixui->led5, offled_xpm);
   fl_set_pixmap_data(mixui->led6, offled_xpm);
   fl_set_pixmap_data(mixui->led7, offled_xpm);
   break; }
  case 6: {
   fl_set_pixmap_data(mixui->led0, greenled_xpm);
   fl_set_pixmap_data(mixui->led1, greenled_xpm);
   fl_set_pixmap_data(mixui->led2, greenled_xpm);
   fl_set_pixmap_data(mixui->led3, greenled_xpm);
   fl_set_pixmap_data(mixui->led4, yelled_xpm);
   fl_set_pixmap_data(mixui->led5, yelled_xpm);
   fl_set_pixmap_data(mixui->led6, offled_xpm);
   fl_set_pixmap_data(mixui->led7, offled_xpm);
   break; }
  case 7: {
   fl_set_pixmap_data(mixui->led0, greenled_xpm);
   fl_set_pixmap_data(mixui->led1, greenled_xpm);
   fl_set_pixmap_data(mixui->led2, greenled_xpm);
   fl_set_pixmap_data(mixui->led3, greenled_xpm);
   fl_set_pixmap_data(mixui->led4, yelled_xpm);
   fl_set_pixmap_data(mixui->led5, yelled_xpm);
   fl_set_pixmap_data(mixui->led6, redled_xpm);
   fl_set_pixmap_data(mixui->led7, offled_xpm);
   break; }
  case 8: {
   fl_set_pixmap_data(mixui->led0, greenled_xpm);
   fl_set_pixmap_data(mixui->led1, greenled_xpm);
   fl_set_pixmap_data(mixui->led2, greenled_xpm);
   fl_set_pixmap_data(mixui->led3, greenled_xpm);
   fl_set_pixmap_data(mixui->led4, yelled_xpm);
   fl_set_pixmap_data(mixui->led5, yelled_xpm);
   fl_set_pixmap_data(mixui->led6, redled_xpm);
   fl_set_pixmap_data(mixui->led7, redled_xpm);
   break; }
  
 }
}

void make_display(char * disp)
{
 printf("%s lamers\n",disp);
}

void do_setup(FD_Mixer *ui)
{
 double mainvol,bass,treble,pcm,synth,cd,linevol,micvol,recvol;
 int capable;
 int play;
 Pixmap p, p1, mask, mask1;
 unsigned w,h;
 
 // set the icon for the mixer
 p = fl_create_from_pixmapdata(fl_root, icon, &w, &h, &mask, 0, 0, 0);
 fl_set_form_icon(ui->Mixer, p, mask);

 make_leds(0);

 ioctl(mixer_fd, SOUND_MIXER_READ_DEVMASK, &capable);
 printf("Capabilities: %d\n", capable);
 if (capable==116209) {
  printf ("Your card appears to be a Ensoniq AudioPCI or a clone, with OSS/Linux\n");
  printf ("Synth slider will now control the PCM2 volume (/dev/dac)\n");
  printf ("If this doesnt work, email me the number from Capabilites line, and card type.\n");
  audiopci=1;
 }

 // prepare the lcval array, load it with current settings;
 for (i = 0; i < SOUND_MIXER_NRDEVICES; i++) {
  d = (1 << i);
  if (0 != (devmask & d)) {
   if (-1 == ioctl(mixer_fd, MIXER_READ(i), &lcval[i])) {
    perror("MIXER_READ");
   }
  }
 }
 // load variables with current settings. No I didnt have to do that but hey
 // who cares?
 mainvol=(((lcval[SOUND_MIXER_VOLUME] & 0x7f)+((lcval[SOUND_MIXER_VOLUME] >>8) & 0x7f))/2)/100.0;
 bass=(((lcval[SOUND_MIXER_BASS] & 0x7f)+((lcval[SOUND_MIXER_BASS] >>8) & 0x7f))/2)/100.0;
 treble=(((lcval[SOUND_MIXER_TREBLE] & 0x7f)+((lcval[SOUND_MIXER_TREBLE] >>8) & 0x7f))/2)/100.0;
 pcm=(((lcval[SOUND_MIXER_PCM] & 0x7f)+((lcval[SOUND_MIXER_PCM] >>8) & 0x7f))/2)/100.0;
 if (!audiopci) 
  synth=(((lcval[SOUND_MIXER_SYNTH] & 0x7f)+((lcval[SOUND_MIXER_SYNTH] >>8) & 0x7f))/2)/100.0;
 else
  synth=(((lcval[SOUND_MIXER_ALTPCM] & 0x7f)+((lcval[SOUND_MIXER_ALTPCM] >>8) & 0x7f))/2)/100.0;
 cd=(((lcval[SOUND_MIXER_CD] & 0x7f)+((lcval[SOUND_MIXER_CD] >>8) & 0x7f))/2)/100.0;
 linevol=(((lcval[SOUND_MIXER_LINE] & 0x7f)+((lcval[SOUND_MIXER_LINE] >>8) & 0x7f))/2)/100.0;
 micvol=(((lcval[SOUND_MIXER_MIC] & 0x7f)+((lcval[SOUND_MIXER_MIC] >>8) & 0x7f))/2)/100.0;
 recvol=(((lcval[SOUND_MIXER_IMIX] & 0x7f)+((lcval[SOUND_MIXER_IMIX] >>8) & 0x7f))/2)/100.0;

 // Find out recording source, and set buttons accordingly
 ioctl(mixer_fd, MIXER_READ(SOUND_MIXER_READ_RECSRC), &recsource);
 play=getbits(recsource,6,1);
 fl_set_button(ui->line_rec,play);
 play=getbits(recsource,7,1);
 fl_set_button(ui->mic_rec,play);
 play=getbits(recsource,8,1);
 fl_set_button(ui->cd_rec,play);

 // hide balance / fade controls at first
 fl_hide_object(mixui->button_fade);
 fl_hide_object(mixui->slider_balance);
 fl_hide_object(mixui->fade_source);
 fl_hide_object(mixui->button_fin);
 fl_hide_object(mixui->button_fout);
 fl_hide_object(mixui->fade_in_delay);
 fl_hide_object(mixui->fade_out_delay);

 // find out mixer capabilities, gray out controls that dont exist
 // this works on my system - sbawe32, audiopci and MSS cards tested
 // this is pretty bloated code, I coulda done it in the for loop but
 // then I would have to somehow block the objects etc

 if (  !((capable & (1<<SOUND_MIXER_VOLUME))?1:0)  ) {
   fl_deactivate_object(mixui->volume_knob);
   fl_set_object_color(mixui->volume_knob,FL_INACTIVE_COL,FL_INACTIVE_COL);
 }
 if (  !((capable & (1<<SOUND_MIXER_VOLUME))?1:0)  ) {
   fl_deactivate_object(mixui->volume_knob);
   fl_set_object_color(mixui->volume_knob,FL_INACTIVE_COL,FL_INACTIVE_COL);
 }
 if (  !((capable & (1<<SOUND_MIXER_PCM))?1:0)  ) {
   fl_deactivate_object(mixui->slider_pcm);
   fl_set_object_color(mixui->slider_pcm,FL_INACTIVE_COL,FL_INACTIVE_COL);
 }
 if (  !((capable & (1<<SOUND_MIXER_CD))?1:0)  ) {
   fl_deactivate_object(mixui->slider_cd);
   fl_set_object_color(mixui->slider_cd,FL_INACTIVE_COL,FL_INACTIVE_COL);
 }
 if (  !((capable & (1<<SOUND_MIXER_BASS))?1:0)  ) {
   fl_deactivate_object(mixui->knob_bass);
   fl_set_object_color(mixui->knob_bass,FL_INACTIVE_COL,FL_INACTIVE_COL);
 }
 if (  !((capable & (1<<SOUND_MIXER_TREBLE))?1:0)  ) {
   fl_deactivate_object(mixui->knob_treble);
   fl_set_object_color(mixui->knob_treble,FL_INACTIVE_COL,FL_INACTIVE_COL);
 }
 if (  !((capable & (1<<SOUND_MIXER_LINE))?1:0)  ) {
   fl_deactivate_object(mixui->slider_line);
   fl_set_object_color(mixui->slider_line,FL_INACTIVE_COL,FL_INACTIVE_COL);
 }
 if (  !((capable & (1<<SOUND_MIXER_MIC))?1:0)  ) {
   fl_deactivate_object(mixui->slider_mic);
   fl_set_object_color(mixui->slider_mic,FL_INACTIVE_COL,FL_INACTIVE_COL);
 }

 // Initialize sliders to 0 -> 1
 fl_set_slider_bounds(ui->slider_line,1.0,0.0);
 fl_set_slider_bounds(ui->slider_mic,1.0,0.0);
 fl_set_slider_bounds(ui->slider_reclevel,1.0,0.0);
 fl_set_slider_bounds(ui->slider_pcm,1.0,0.0);
 fl_set_slider_bounds(ui->slider_synth,1.0,0.0);
 fl_set_slider_bounds(ui->slider_cd,1.0,0.0);
 fl_set_slider_bounds(ui->slider_mix,1.0,0.0);
 
 // Set all sliders to their respective values from the mixer
 fl_set_slider_value(ui->slider_line, linevol);
 fl_set_slider_value(ui->slider_mic, micvol);
 fl_set_slider_value(ui->slider_reclevel, recvol);
 fl_set_slider_value(ui->slider_pcm, pcm);
 fl_set_slider_value(ui->slider_synth, synth);
 fl_set_slider_value(ui->slider_cd, cd);
 
 // Set all knobs to return values immediately after change
 fl_set_dial_return(ui->volume_knob,FL_RETURN_CHANGED);
 fl_set_dial_return(ui->knob_bass,FL_RETURN_CHANGED);
 fl_set_dial_return(ui->knob_treble,FL_RETURN_CHANGED);

 // Setup
 // main volume knob according to the mixer, same for bass & treble
 fl_set_dial_value(ui->volume_knob,mainvol);
 // make volume leds change
 make_leds(calc_leds(mainvol*100));

 fl_set_dial_value(ui->knob_bass,bass);
 fl_set_dial_value(ui->knob_treble,treble);

 // cool part - setup the choice menus
 // even if the control doesnt exist it still assigns it
 // will fix later hopefully - left & right side
 fl_addto_choice(ui->mix_left, "Line");
 fl_addto_choice(ui->mix_left, "Mic");
 fl_addto_choice(ui->mix_left, "CD");
 fl_addto_choice(ui->mix_left, "PCM");
 fl_addto_choice(ui->mix_left, "Synth");
 fl_addto_choice(ui->mix_right, "Line");
 fl_addto_choice(ui->mix_right, "Mic");
 fl_addto_choice(ui->mix_right, "CD");
 fl_addto_choice(ui->mix_right, "PCM");
 fl_addto_choice(ui->mix_right, "Synth");

 fl_set_choice(ui->mix_left,dev_left);
 fl_set_choice(ui->mix_right,dev_right);

}

void slider_line_cb(FL_OBJECT *ob, long data)
{
 struct stereovolume linevol;
 double value;

 value=fl_get_slider_value(ob);
 linevol.left=linevol.right=value*100;
 ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_LINE), &linevol);
}

void slider_mic_cb(FL_OBJECT *ob, long data)
{
 struct stereovolume micvol;
 double value;

 value=fl_get_slider_value(ob);
 micvol.left=micvol.right=value*100;
 ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_MIC), &micvol);
}

void slider_reclevel_cb(FL_OBJECT *ob, long data)
{
 struct stereovolume recvol;
 double value;

 value=fl_get_slider_value(ob);
 recvol.left=recvol.right=value*100;
 ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_IMIX), &recvol);
}

void slider_mix_cb(FL_OBJECT *ob, long data)
{
 struct stereovolume genvol;
 double value;
 value=fl_get_slider_value(ob);

// lets try this hack
// 1=line 2=mic 3=cd 4=pcm, 5=synth
// trying to fade from the same device is kinda gay.
// later on I might just take out hte choice off hte menu which is already
// selected.
if (dev_left==dev_right) return;

switch (dev_left) {
 case 1: { 
  fl_set_slider_value(mixui->slider_line,value);
  genvol.left=genvol.right=value*100;
  ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_LINE), &genvol);
  break;
 }
 case 2: {
  fl_set_slider_value(mixui->slider_mic,value);
  genvol.left=genvol.right=value*100;
  ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_MIC), &genvol);
  break; }
 case 3: {
  fl_set_slider_value(mixui->slider_cd,value);
  genvol.left=genvol.right=value*100;
  ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_CD), &genvol);
  break; }
 case 4: {
  fl_set_slider_value(mixui->slider_pcm,value);
  genvol.left=genvol.right=value*100;
  ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_PCM), &genvol);
  break; }
 case 5: {
  fl_set_slider_value(mixui->slider_synth,value);
  genvol.left=genvol.right=value*100;
  if (!audiopci)
   ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_SYNTH), &genvol);
  else
   ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_ALTPCM), &genvol);
  break; }
}

switch (dev_right) {
 case 1: {
  fl_set_slider_value(mixui->slider_line,1.0-value);
  genvol.left=genvol.right=((1.0-value)*100);
  ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_LINE), &genvol);
  break; }
 case 2: {
  fl_set_slider_value(mixui->slider_mic,1.0-value);
  genvol.left=genvol.right=((1.0-value)*100);
  ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_MIC), &genvol);
  break; }
 case 3: {
  fl_set_slider_value(mixui->slider_cd,1.0-value);
  genvol.left=genvol.right=((1.0-value)*100);
  ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_CD), &genvol);
  break; }
 case 4: {
  fl_set_slider_value(mixui->slider_pcm,1.0-value);
  genvol.left=genvol.right=((1.0-value)*100);
  ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_PCM), &genvol);
  break; }
 case 5: {
  fl_set_slider_value(mixui->slider_synth,1.0-value);
  genvol.left=genvol.right=((1.0-value)*100);
  if (!audiopci)
   ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_SYNTH), &genvol);
  else
   ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_ALTPCM), &genvol);
  break; }
}
}

void mic_rec_cb(FL_OBJECT *ob, long data)
{
 int value;
 extern int recsource;
 value=fl_get_button(ob);
 if (value)
  recsource=recsource|128;
 else
  recsource=recsource&0x17f;
 ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_WRITE_RECSRC), &recsource);
}

void line_rec_cb(FL_OBJECT *ob, long data)
{
 int value;
 extern int recsource;
 value=fl_get_button(ob);
 if (value)
  recsource=recsource|64;
 else
  recsource=recsource&0x1bf;
 ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_WRITE_RECSRC), &recsource);
}

void cd_rec_cb(FL_OBJECT *ob, long data)
{
 int value;
 extern int recsource;
 value=fl_get_button(ob);
 if (value)
  recsource=recsource|256;
 else
  recsource=recsource&0xff;
 ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_WRITE_RECSRC), &recsource);
}


void volume_knob_cb(FL_OBJECT *ob, long data)
{
 struct stereovolume mainvol;
 double value;

 value=fl_get_dial_value(ob);

 make_leds(calc_leds(value*100));

 mainvol.left=mainvol.right=value*100;
 ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_VOLUME), &mainvol);

}

void knob_bass_cb(FL_OBJECT *ob, long data)
{
 struct stereovolume bass;
 double value;
 value=fl_get_dial_value(ob);
 bass.left=bass.right=value*100;
 ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_BASS), &bass);
}

void knob_treble_cb(FL_OBJECT *ob, long data)
{
 struct stereovolume treble;
 double value;
 value=fl_get_dial_value(ob);
 treble.left=treble.right=value*100;
 ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_TREBLE), &treble);
}

void slider_pcm_cb(FL_OBJECT *ob, long data)
{
 struct stereovolume pcm;
 double value;

 value=fl_get_slider_value(ob);
 pcm.left=pcm.right=value*100;
 ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_PCM), &pcm);
}

void slider_synth_cb(FL_OBJECT *ob, long data)
{
 struct stereovolume synth;
 double value;

 value=fl_get_slider_value(ob);
 synth.left=synth.right=value*100;
 if (!audiopci)
  ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_SYNTH), &synth);
 else
  ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_ALTPCM), &synth);
}

void slider_cd_cb(FL_OBJECT *ob, long data)
{
 struct stereovolume cd;
 double value;

 value=fl_get_slider_value(ob);
 cd.left=cd.right=value*100;
 ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_CD), &cd);
}

void mix_left_cb(FL_OBJECT *ob, long data)
{
 dev_left=fl_get_choice(ob);
}

void mix_right_cb(FL_OBJECT *ob, long data)
{
 dev_right=fl_get_choice(ob);
}

void if_button_cb(FL_OBJECT *ob, long data)
{
 static int value;
 
 value=!value;

if (!value) {
 // hide faders
 fl_hide_object(mixui->button_fade);
 fl_hide_object(mixui->slider_balance);
 fl_hide_object(mixui->fade_source);
 fl_hide_object(mixui->button_fin);
 fl_hide_object(mixui->button_fout);
 fl_hide_object(mixui->fade_in_delay);
 fl_hide_object(mixui->fade_out_delay);
 // show volume
 fl_show_object(mixui->volume_knob);
 fl_set_object_label(mixui->if_button,"Faders");
} else {
 // show faders
 fl_show_object(mixui->button_fade);
 fl_show_object(mixui->slider_balance);
 fl_show_object(mixui->fade_source);
 fl_show_object(mixui->button_fin);
 fl_show_object(mixui->button_fout);
 fl_show_object(mixui->fade_in_delay);
 fl_show_object(mixui->fade_out_delay);
 // hide volume
 fl_hide_object(mixui->volume_knob);
 fl_set_object_label(mixui->if_button,"No Faders");
 }
}

void button_fade_cb(FL_OBJECT *ob, long data)
{ }

void slider_balance_cb(FL_OBJECT *ob, long data)
{ }

void fade_source_cb(FL_OBJECT *ob, long data)
{ }

void button_fin_cb(FL_OBJECT *ob, long data)
{ }
void button_fout_cb(FL_OBJECT *ob, long data)
{ }
void fade_in_delay_cb(FL_OBJECT *ob, long data)
{ } 
void fade_out_delay_cb(FL_OBJECT *ob, long data)
{ }

void button_quit_cb(FL_OBJECT *ob, long data)
{
  exit(0);
}
